---
title: 'RangeError: radix must be an integer'
slug: Web/JavaScript/Reference/Errors/Bad_radix
tags:
  - Error
  - Errors
  - JavaScript
  - RangeError
---
<div>{{jsSidebar("Errors")}}</div>

<p>The JavaScript exception "radix must be an integer at least 2 and no greater than 36" occurs when the optional <code>radix</code> parameter of the {{jsxref("Number.prototype.toString()")}} or the {{jsxref("BigInt.prototype.toString()")}} method was specified and is not between 2 and 36.</p>

<h2 id="Message">Message</h2>

<pre class="syntaxbox">RangeError: invalid argument (Edge)
RangeError: radix must be an integer at least 2 and no greater than 36 (Firefox)
RangeError: toString() radix argument must be between 2 and 36 (Chrome)
</pre>

<h2 id="Error_type">Error type</h2>

<p>{{jsxref("RangeError")}}</p>

<h2 id="What_went_wrong">What went wrong?</h2>

<p>The optional <code>radix</code> parameter of the {{jsxref("Number.prototype.toString()")}} or the {{jsxref("BigInt.prototype.toString()")}} method was specified. Its value must be an integer (a number) between 2 and 36, specifying the base of the number system to be used for representing numeric values. For example, the decimal (base 10) number 169 is represented in hexadecimal (base 16) as A9.</p>

<p>Why is this parameter's value limited to 36? A radix that is larger than 10 uses alphabetical characters as digits; therefore, the radix can't be larger than 36, since the Latin alphabet (used by English and many other languages) only has 26 characters.</p>

<p>The most common radixes:</p>

<ul>
 <li>2 for <a href="https://en.wikipedia.org/wiki/Binary_number">binary numbers</a>,</li>
 <li>8 for <a href="https://en.wikipedia.org/wiki/Octal">octal numbers</a>,</li>
 <li>10 for <a href="https://en.wikipedia.org/wiki/Decimal">decimal numbers</a>,</li>
 <li>16 for <a href="https://en.wikipedia.org/wiki/Hexadecimal">hexadecimal numbers</a>.</li>
</ul>

<h2 id="Examples">Examples</h2>

<h3 id="Invalid_cases">Invalid cases</h3>

<pre class="brush: js example-bad">(42).toString(0);
(42).toString(1);
(42).toString(37);
(42).toString(150);
// You cannot use a string like this for formatting:
(12071989).toString('MM-dd-yyyy');
</pre>

<h3 id="Valid_cases">Valid cases</h3>

<pre class="brush: js example-good">(42).toString(2);     // "101010" (binary)
(13).toString(8);     // "15"     (octal)
(0x42).toString(10);  // "66"     (decimal)
(100000).toString(16) // "186a0"  (hexadecimal)
</pre>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{jsxref("Number.prototype.toString()")}}</li>
 <li>{{jsxref("BigInt.prototype.toString()")}}</li>
</ul>
